"""  
File: enlarge.py
Tests a function for blurring a color image.
"""

from images import Image

def blur(image):
    """Builds and returns a new image which is a blurred copy of the argument image."""

    def tripleSum((r1, g1, b1), (r2, g2, b2)):
        return (r1 + r2, g1 + g2, b1 + b2)

    new = image.clone()
    
    for y in xrange(1,image.getHeight()-1):
        for x in xrange(1, image.getWidth()-1):
            oldP = image.getPixel(x, y)
            left = image.getPixel(x-1, y)
            right = image.getPixel(x+1, y)
            top = image.getPixel(x, y-1)
            bottom = image.getPixel(x, y+1)
            sums = reduce(tripleSum, [oldP, left, right, top, bottom])
            averages = tuple(map(lambda x: x / 5, sums))
            new.setPixel(x, y, averages)
            
    return new


def main(filename = "smokey.gif"):
    image = Image(filename)
    print "Image before enlarging.  Close the image window to quit. "
    image.draw()

    blurredImage = blur(image)
    print "Image after blurring.  Close the image window to quit. "
    blurredImage.draw()
    print "after draw, but before save"
    blurredImage.save("blurred.gif")
    print "after save"

main()
